#include <stdio.h>
#include <stdlib.h>

short hasRealEventsPre(short idx)
{
    char name[255];
    FILE *f;
    unsigned char mychar;
    sprintf(name,"PrePost_Events\\%ipre.h",idx);
    f = fopen(name,"rt");
    if(!f) return;
    
    while(!feof(f))
    {
        mychar = fgetc(f);
        if(mychar!=' ' && mychar != '\t' && mychar != '\n' 
         && mychar !=13 && mychar != 10 && mychar !=255)
        //not whitespace
        {
        //printf("[%c %i]",mychar,mychar);
        fclose(f);
        return 1;
        }
    }
    fclose(f);
    return 0;
}

short hasRealEventsPost(short idx)
{
    char name[255];
    FILE *f;
    unsigned char mychar;
    sprintf(name,"PrePost_Events\\%ipost.h",idx);
    f = fopen(name,"rt");
    if(!f) return;
    
    while(!feof(f))
    {
        mychar = fgetc(f);
        if(mychar!=' ' && mychar != '\t' && mychar != '\n' 
         && mychar !=13 && mychar != 10 && mychar !=255)
        //not whitespace
        {
        //printf("[%c %i]",mychar,mychar);
        fclose(f);
        return 1;
        }
    }
    fclose(f);
    return 0;
}

int main(int argc, char *argv[])
{
  short num;
  char nums[20];
  char filename[50];
  FILE *f;
  short a;
  
  f = fopen("maps.txt","rt");
  if(!f)
   {
  printf("Couldn't open find maps.txt for opening!\n");
  printf("Run this tool from the /levels/ folder.\n");
  system("pause");
  return 1;
  }
  a=0;
  do
  {
    nums[a] = fgetc(f);
    a++;
  } while(nums[a-1]!=',');
  nums[a] = 0;
  num = atoi(nums) - 1;
  fclose(f);
  
  //printf("Num: %i",num);
  for(a=1;a<=num;a++)
{
sprintf(filename,"PrePost_Events\\%ipre.h",a);
f = fopen(filename,"rt");
if(!f) 
{
f = fopen(filename,"wt");
fputc('\n',f);
fclose(f);
}
fclose(f);

sprintf(filename,"PrePost_Events\\%ipost.h",a);
f = fopen(filename,"rt");
if(!f) 
{
f = fopen(filename,"wt");
fputc('\n',f);
fclose(f);
}
fclose(f);
}
  
  f = fopen("..\\src\\lev_special.h","wt");
  if(!f) 
  {
  printf("Couldn't open ..\\src\\lev_special.h for writing.\n");
  system("pause");
  return 1;
  }
  
fprintf(f,"
static inline void RunPreLevelTasks(void)
{
  fc=fc;
  register GameGlobals *ggg asm(\"a4\") = gg;
  switch(ggg->current_level) 
  {
  ");
for(a=1;a<=num;a++)
{
if(hasRealEventsPre(a))
fprintf(f,"
case %i:
",a);
{
sprintf(filename,"PrePost_Events\\%ipre.h",a);
FILE *g = fopen(filename,"rt");
  if(!g) 
  {
  printf("Couldn't open %s for writing.\n",filename);
  system("pause");
  return 1;
  } 
while(1)
{
char z = fgetc(g);
if(feof(g)) break;
fputc(z,f);
}
}
if(hasRealEventsPre(a)) fprintf(f,"
break;
");
}
fprintf(f,"
}
}
");
fprintf(f,"
static inline void RunPostLevelTasks(void)
{
  fc=fc;
  register GameGlobals *ggg asm(\"a4\") = gg;
  switch(ggg->current_level) 
  {
  ");
for(a=1;a<=num;a++)
{
if(hasRealEventsPost(a))
fprintf(f,"
case %i:
",a);
{
sprintf(filename,"PrePost_Events\\%ipost.h",a);
FILE *g = fopen(filename,"rt");
  if(!g) 
  {
  printf("Couldn't open %s for writing.\n",filename);
  system("pause");
  return 1;
  } 
while(1)
{
char z = fgetc(g);
if(feof(g)) break;
fputc(z,f);
}
}
if(hasRealEventsPost(a)) fprintf(f,"
break;
");
}
fprintf(f,"
}
}
");

fclose(f);


system("pause");
  return 0;
}
