#include <stdio.h>
#include "text.h"


typedef struct
{
const char* const* ptr;
short offset;
char *name;
} Text;
#define T(a) (Text){a,0,#a}

#define MYSWAP(a) ((a<<8)|(a>>8))

//#define TEXTCOUNT 1

#include "names.h"

int main(int argc, char *argv[])
{
  FILE *f = fopen("oblvtext.bin","wb");
  FILE *f2 = fopen("temp.bin","wb");
  char buffer[255];
  short a,i=0;
  short offset = 0;

  if(!f || !f2)
  {
    printf("Couldn't open oblvtext/temp.bin for writing\n");
    system("PAUSE");
    return 1;
  }
  for(a=0;a<(signed)sizeof(text)/sizeof(text[0]);a++)
  {
    char src;
    long first;
    short lines = 0,y=0;
    while(text[a].ptr[lines++]);
    lines--;
    //for(i=0;i<lines;i++)   {
    //  printf("%i: %s\t\t%i\n",i,text[a].ptr[i],y);
    //  y+=strlen(text[a].ptr[i]);   }
    {
    short o[lines];
    text[a].offset = offset;
    first = *((long*)text[a].ptr);
    //printf("first: %li\n",first);
    {
     short z = lines;
     z = MYSWAP(z);
     fwrite(&z,sizeof(short),1,f2);
     offset+=sizeof(short);
    }
    for(i=0;i<lines;i++)
    {
     short size;
     /*long lsize;
     lsize = *((long*)text[a].ptr+i);
     //printf("lsize1: %li\n",lsize);
	 lsize = first - lsize;
     //printf("lsize2: %li\n",lsize);
	 size = (short)lsize; */
       size = y;
       y+=strlen(text[a].ptr[i])+1;
     o[i] = size;
     //printf("o[%i]: %i\n",i,o[i]);
     size = MYSWAP(size);
     fwrite(&size,sizeof(short),1,f2);
     offset+=sizeof(short);
    }
    for(i=0;i<lines;i++)
    {
     fwrite(text[a].ptr[i],sizeof(char),strlen(text[a].ptr[i])+1,f2);
     offset+=strlen(text[a].ptr[i])+1;
    }    
	if(offset&0x1) //Odd, pad with zero
	{
	fputc(0,f2);
	offset++;
	}
		{
		short c = MYSWAP(text[a].offset);
		fwrite(&c,sizeof(short),1,f);
		}	
  //printf("Offset: %i %X\n",text[a].offset,text[a].offset);
    }
  }
  fclose(f2);
  f2 = fopen("temp.bin","rb");
  while(!feof(f2))
  {
  	fputc(fgetc(f2),f);
  }
  fclose(f2);
  fclose(f);
  
  //sprintf(buffer,"set path=%%path%%;..\\..\\tools");
  //system(buffer);
  //sprintf(buffer,"ttpack oblvtext.bin text.bin");
  //system(buffer);
  sprintf(buffer,"ttbin2oth -89 oblv oblvtext.bin oblvtext oblivion");
  system(buffer);
  sprintf(buffer,"ttbin2oth -92 oblv oblvtext.bin oblvtext oblivion");
  system(buffer);
  sprintf(buffer,"del oblvtext.bin");
  system(buffer);
  sprintf(buffer,"del temp.bin");
  system(buffer);
  sprintf(buffer,"move oblvtext.89y ../../89/oblvtext.89y");
  system(buffer);
  sprintf(buffer,"move oblvtext.9xy ../../92p_v200/oblvtext.9xy");
  system(buffer);
  
  
  f = fopen("..\\..\\src\\oblvtext.h","wt");
  if(!f)
  {
    printf("Couldn't open oblvtext.h for writing\n");
    system("PAUSE");
    return 1;
  }
  for(a=0;a<sizeof(text)/sizeof(text[0]);a++)
  {
   fprintf(f,"#define %s %i\n",
        text[a].name,a);
  }
   fprintf(f,"#define oblvtext_count %i\n",a);
  printf("Successfully made oblvtext.89y/9xy and oblvtext. (Size: %i).\n",offset);
  printf("%i Texts.\n\n",(signed)sizeof(text)/sizeof(text[0]));
  return 0;
}
